diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLeavesCacao.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLeavesCacao.java
index 1c856ba54..15d652fce 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLeavesCacao.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLeavesCacao.java
@@ -2,7 +2,7 @@ package net.minecraft.core.block;
 
 import net.minecraft.core.block.entity.TileEntityActivator;
 import net.minecraft.core.block.entity.TileEntity;
-import net.minecraft.core.block.material.Material;
+import net.minecraft.core.block.material.Materials;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.IBonemealable;
@@ -14,6 +14,7 @@ import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import net.minecraft.core.world.season.Seasons;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
@@ -25,16 +26,17 @@ public class BlockLogicLeavesCacao extends BlockLogicLeavesBase implements IBone
     public static final int MASK_GROWTH_DATA = 0b1111_0000;
     public static final int MAX_GROWTH_STATE = 4;
     static final int BEAN_GROWTH_RATE = 50;
+
     public BlockLogicLeavesCacao(@NotNull Block<?> block) {
-        super(block, Material.leaves, Blocks.SAPLING_CACAO);
+        super(block, Materials.LEAVES, Blocks.SAPLING_CACAO);
         block.setTicking(true);
     }
 
-    public boolean canBeansGrow(@NotNull World world, @NotNull TilePos tilePos){
-        TilePos p = new TilePos(tilePos);
-        for(int x = tilePos.x - 1; x < tilePos.x + 1; x++){
-            for(int z = tilePos.z - 1; z < tilePos.z + 1; z++){
-                if (world.getBlock(p.set(x, tilePos.y, z)) == null) {
+    public boolean canBeansGrow(@NotNull World world, @NotNull TilePosc tilePos) {
+        TilePos queryPos = new TilePos(tilePos);
+        for (int x = tilePos.x() - 1; x < tilePos.x() + 1; x++) {
+            for (int z = tilePos.z() - 1; z < tilePos.z() + 1; z++) {
+                if (world.getBlock(queryPos.set(x, tilePos.y(), z)) == null) {
                     return true;
                 }
             }
@@ -44,40 +46,40 @@ public class BlockLogicLeavesCacao extends BlockLogicLeavesBase implements IBone
 
     @Override
     public ItemStack[] getBreakResult(@NotNull World world, @NotNull EnumDropCause dropCause, int data, @Nullable TileEntity tileEntity) {
-        if (dropCause == EnumDropCause.PICK_BLOCK || dropCause == EnumDropCause.SILK_TOUCH) return new ItemStack[] { new ItemStack(this) };
+        if (dropCause == EnumDropCause.PICK_BLOCK || dropCause == EnumDropCause.SILK_TOUCH)
+            return new ItemStack[]{new ItemStack(this)};
 
         int growthRate = getGrowthRate(data);
-        if (growthRate > 1)
-        {
-            return new ItemStack[] { new ItemStack(Items.DYE, MathHelper.ceil((double) growthRate / 2), DyeColor.BROWN.itemMeta)};
+        if (growthRate > 1) {
+            return new ItemStack[]{new ItemStack(Items.DYE, MathHelper.ceil((double) growthRate / 2), DyeColor.BROWN.itemMeta)};
         }
 
         return super.getBreakResult(world, dropCause, data, tileEntity);
     }
 
     @Override
-    public void onAttacked(@NotNull World world, @NotNull TilePos tilePos, @NotNull Player player, @NotNull Side side, double xHit, double yHit) {
+    public void onAttacked(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Player player, @NotNull Side side, double xHit, double yHit) {
         onInteracted(world, tilePos, player, side, xHit, yHit);
     }
 
     @Override
-    public boolean onInteracted(@NotNull World world, @NotNull TilePos tilePos, @NotNull Player player, @Nullable Side side, double xHit, double yHit) {
+    public boolean onInteracted(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Player player, @Nullable Side side, double xHit, double yHit) {
         return harvest(world, tilePos, player);
     }
 
     @Override
-    public void onActivatorInteracted(@NotNull World world, @NotNull TilePos tilePos, @NotNull TileEntityActivator activator, @NotNull Direction direction) {
+    public void onActivatorInteracted(@NotNull World world, @NotNull TilePosc tilePos, @NotNull TileEntityActivator activator, @NotNull Direction direction) {
         harvest(world, tilePos, null);
     }
 
-    public boolean harvest(@NotNull World world, @NotNull TilePos tilePos, @Nullable Player player) {
+    public boolean harvest(@NotNull World world, @NotNull TilePosc tilePos, @Nullable Player player) {
         int meta = world.getBlockData(tilePos);
         int growthRate = getGrowthRate(meta);
-        if(growthRate > 0) {
+        if (growthRate > 0) {
             if (player != null) {
                 world.playSoundAtEntity(player, player, "item.pickup", 1, 1);
             }
-            if(!world.isClientSide) {
+            if (!world.isClientSide) {
                 dropWithCause(world, EnumDropCause.WORLD, tilePos, meta, null, null);
             }
             world.setBlockDataNotify(tilePos, setGrowthRate(meta, 0));
@@ -88,7 +90,7 @@ public class BlockLogicLeavesCacao extends BlockLogicLeavesBase implements IBone
     }
 
     @Override
-    public void updateTick(@NotNull World world, @NotNull TilePos tilePos, @NotNull Random rand, boolean isRandomTick) {
+    public void updateTick(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Random rand, boolean isRandomTick) {
         super.updateTick(world, tilePos, rand, isRandomTick);
         int meta = world.getBlockData(tilePos);
         int growthRate = getGrowthRate(meta);
@@ -100,8 +102,7 @@ public class BlockLogicLeavesCacao extends BlockLogicLeavesBase implements IBone
                         world.scheduleBlockUpdate(tilePos, Blocks.LEAVES_CACAO.id(), tickDelay());
                     }
                 }
-            }
-            else if(growthRate > 0){
+            } else if (growthRate > 0) {
                 world.setBlockDataNotify(tilePos, setGrowthRate(meta, 0));
                 world.scheduleBlockUpdate(tilePos, Blocks.LEAVES_CACAO.id(), tickDelay());
             }
@@ -109,17 +110,14 @@ public class BlockLogicLeavesCacao extends BlockLogicLeavesBase implements IBone
     }
 
     @Override
-    public boolean onBonemealUsed(@NotNull ItemStack itemStack, @Nullable Player player, @NotNull World world, @NotNull TilePos tilePos, @NotNull Side side, double xHit, double yHit) {
+    public boolean onBonemealUsed(@NotNull ItemStack itemStack, @Nullable Player player, @NotNull World world, @NotNull TilePosc tilePos, @NotNull Side side, double xHit, double yHit) {
         int meta = world.getBlockData(tilePos);
-        if(getGrowthRate(meta) < MAX_GROWTH_STATE)
-        {
-            if(!world.isClientSide)
-            {
-                if(world.getSeasonManager().getCurrentSeason() != Seasons.OVERWORLD_SUMMER)
+        if (getGrowthRate(meta) < MAX_GROWTH_STATE) {
+            if (!world.isClientSide) {
+                if (world.getSeasonManager().getCurrentSeason() != Seasons.OVERWORLD_SUMMER)
                     return true;
                 world.setBlockDataNotify(tilePos, setGrowthRate(meta, MAX_GROWTH_STATE));
-                if (player == null || player.getGamemode().consumeBlocks())
-                {
+                if (player == null || player.getGamemode().consumeBlocks()) {
                     itemStack.stackSize--;
                 }
             }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLeavesCherry.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLeavesCherry.java
index 69f9d0674..21bb9bb7b 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLeavesCherry.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLeavesCherry.java
@@ -1,25 +1,23 @@
 package net.minecraft.core.block;
 
+import net.minecraft.core.block.material.Materials;
 import net.minecraft.core.world.World;
-import net.minecraft.core.block.material.Material;
-import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import net.minecraft.core.world.season.Seasons;
 import org.jetbrains.annotations.NotNull;
 
 import java.util.Random;
 
-public class BlockLogicLeavesCherry extends BlockLogicLeavesBase
-{
+public class BlockLogicLeavesCherry extends BlockLogicLeavesBase {
 
-	public BlockLogicLeavesCherry(@NotNull Block<?> block)
-    {
-        super(block, Material.leaves, Blocks.SAPLING_CHERRY);
+    public BlockLogicLeavesCherry(@NotNull Block<?> block) {
+        super(block, Materials.LEAVES, Blocks.SAPLING_CHERRY);
     }
 
     @Override
-	public void animationTick(@NotNull World world, @NotNull TilePos tilePos, @NotNull Random rand) {
+    public void animationTick(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Random rand) {
         if (world.getSeasonManager().getCurrentSeason() != null && world.getSeasonManager().getCurrentSeason() == Seasons.OVERWORLD_SPRING && rand.nextInt(40) == 0) {
-            world.spawnParticle("fallingleaf", tilePos.x, (double) tilePos.y - 0.1f, tilePos.z, 0, 0, 0, 0);
+            world.spawnParticle("fallingleaf", tilePos.x(), (double) tilePos.y() - 0.1f, tilePos.z(), 0, 0, 0, 0);
         }
     }
 
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLeavesCherryFlowering.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLeavesCherryFlowering.java
index b50d51a5c..3f4badadd 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLeavesCherryFlowering.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLeavesCherryFlowering.java
@@ -10,7 +10,7 @@ import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
-import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import net.minecraft.core.world.season.Seasons;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
@@ -38,16 +38,16 @@ public class BlockLogicLeavesCherryFlowering extends BlockLogicLeavesCherry impl
     }
 
     @Override
-    public void onAttacked(@NotNull World world, @NotNull TilePos tilePos, @NotNull Player player, @NotNull Side side, double xHit, double yHit) {
+    public void onAttacked(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Player player, @NotNull Side side, double xHit, double yHit) {
         onInteracted(world, tilePos, player, side, xHit, yHit);
     }
 
     @Override
-    public boolean onInteracted(@NotNull World world, @NotNull TilePos tilePos, @NotNull Player player, @Nullable Side side, double xHit, double yHit) {
+    public boolean onInteracted(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Player player, @Nullable Side side, double xHit, double yHit) {
         return harvest(world, tilePos, player);
     }
 
-    public boolean harvest(@NotNull World world, @NotNull TilePos tilePos, @Nullable Player player) {
+    public boolean harvest(@NotNull World world, @NotNull TilePosc tilePos, @Nullable Player player) {
         int meta = world.getBlockData(tilePos);
         int growthRate = getGrowthRate(meta);
         if(growthRate > 0) {
@@ -65,12 +65,12 @@ public class BlockLogicLeavesCherryFlowering extends BlockLogicLeavesCherry impl
     }
 
     @Override
-    public void onActivatorInteracted(@NotNull World world, @NotNull TilePos tilePos, @NotNull TileEntityActivator activator, @NotNull Direction direction) {
+    public void onActivatorInteracted(@NotNull World world, @NotNull TilePosc tilePos, @NotNull TileEntityActivator activator, @NotNull Direction direction) {
         harvest(world, tilePos, null);
     }
 
     @Override
-	public void updateTick(@NotNull World world, @NotNull TilePos tilePos, @NotNull Random rand, boolean isRandomTick) {
+	public void updateTick(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Random rand, boolean isRandomTick) {
         super.updateTick(world, tilePos, rand, isRandomTick);
         int meta = world.getBlockData(tilePos);
         int growthRate = getGrowthRate(meta);
@@ -89,7 +89,7 @@ public class BlockLogicLeavesCherryFlowering extends BlockLogicLeavesCherry impl
     }
 
     @Override
-    public boolean onBonemealUsed(@NotNull ItemStack itemStack, @Nullable Player player, @NotNull World world, @NotNull TilePos tilePos, @NotNull Side side, double xHit, double yHit) {
+    public boolean onBonemealUsed(@NotNull ItemStack itemStack, @Nullable Player player, @NotNull World world, @NotNull TilePosc tilePos, @NotNull Side side, double xHit, double yHit) {
         int meta = world.getBlockData(tilePos);
         if(getGrowthRate(meta) == 0) {
             if(!world.isClientSide) {
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLeavesEucalyptus.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLeavesEucalyptus.java
index 0e9686b3e..ded4141a8 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLeavesEucalyptus.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLeavesEucalyptus.java
@@ -1,21 +1,21 @@
 package net.minecraft.core.block;
 
+import net.minecraft.core.block.material.Materials;
 import net.minecraft.core.world.World;
-import net.minecraft.core.block.material.Material;
-import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 
 import java.util.Random;
 
 public class BlockLogicLeavesEucalyptus extends BlockLogicLeavesBase {
-	public BlockLogicLeavesEucalyptus(@NotNull Block<?> block) {
-        super(block, Material.leaves, Blocks.SAPLING_EUCALYPTUS);
+    public BlockLogicLeavesEucalyptus(@NotNull Block<?> block) {
+        super(block, Materials.LEAVES, Blocks.SAPLING_EUCALYPTUS);
     }
 
     @Override
-	public void animationTick(@NotNull World world, @NotNull TilePos tilePos, @NotNull Random rand) {
-    	if (world.getSeasonManager().getCurrentSeason() != null && world.getSeasonManager().getCurrentSeason().hasFallingLeaves && rand.nextInt(40) == 0) {
-    		world.spawnParticle("fallingleaf", tilePos.x, (double) tilePos.y - 0.1f, tilePos.z, 0, 0, 0, 0);
-    	}
+    public void animationTick(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Random rand) {
+        if (world.getSeasonManager().getCurrentSeason() != null && world.getSeasonManager().getCurrentSeason().hasFallingLeaves && rand.nextInt(40) == 0) {
+            world.spawnParticle("fallingleaf", tilePos.x(), (double) tilePos.y() - 0.1f, tilePos.z(), 0, 0, 0, 0);
+        }
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLeavesOak.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLeavesOak.java
index 532b16294..bb2701a04 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLeavesOak.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLeavesOak.java
@@ -1,35 +1,34 @@
 package net.minecraft.core.block;
 
+import net.minecraft.core.block.material.Materials;
 import net.minecraft.core.world.World;
-import net.minecraft.core.block.material.Material;
 import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import net.minecraft.core.world.wind.WindProvider;
 import org.jetbrains.annotations.NotNull;
 
 import java.util.Random;
 
-public class BlockLogicLeavesOak extends BlockLogicLeavesBase
-{
-	public BlockLogicLeavesOak(@NotNull Block<?> block)
-    {
-        super(block, Material.leaves, Blocks.SAPLING_OAK);
+public class BlockLogicLeavesOak extends BlockLogicLeavesBase {
+    public BlockLogicLeavesOak(@NotNull Block<?> block) {
+        super(block, Materials.LEAVES, Blocks.SAPLING_OAK);
     }
 
     @Override
-	public void updateTick(@NotNull World world, @NotNull TilePos tilePos, @NotNull Random rand, boolean isRandomTick)
-    {
+    public void updateTick(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Random rand, boolean isRandomTick) {
         super.updateTick(world, tilePos, rand, isRandomTick);
         if (rand.nextInt(128) == 0 && world.getSeasonManager().getCurrentSeason() != null && world.getSeasonManager().getCurrentSeason().hasFallingLeaves) {
-            TilePos p = new TilePos(tilePos);
+            TilePos queryPos = new TilePos();
             for (int q = -1; q > -16; q--) {
-                p.y = tilePos.y + q;
-                int id = world.getBlockId(p);
+                int id = world.getBlockId(tilePos.add(0, q, 0, queryPos));
                 if (id != 0) break;
-                if (Blocks.LAYER_LEAVES_OAK.canPlaceAt(world, p) && Blocks.blocksList[world.getBlockId(p.down())].getMaterial().blocksMotion()) {
-                    world.setBlockIdNotify(p, Blocks.LAYER_LEAVES_OAK.id());
+                if (Blocks.LAYER_LEAVES_OAK.canPlaceAt(world, tilePos.add(0, q, 0, queryPos)) &&
+                    Blocks.blocksList[world.getBlockId(tilePos.add(0, q - 1, 0, queryPos))].getMaterial().blocksMotion()) {
+
+                    world.setBlockIdNotify(tilePos.add(0, q, 0, queryPos), Blocks.LAYER_LEAVES_OAK.id());
                     break;
-                } else if (world.getBlockId(p) == Blocks.LAYER_LEAVES_OAK.id()) {
-                    Blocks.LAYER_LEAVES_OAK.getLogic().accumulate(world, p);
+                } else if (world.getBlockId(tilePos.add(0, q, 0, queryPos)) == Blocks.LAYER_LEAVES_OAK.id()) {
+                    Blocks.LAYER_LEAVES_OAK.getLogic().accumulate(world, queryPos);
                     break;
                 }
             }
@@ -37,14 +36,13 @@ public class BlockLogicLeavesOak extends BlockLogicLeavesBase
     }
 
     @Override
-    public void animationTick(@NotNull World world, @NotNull TilePos tilePos, @NotNull Random rand) {
-    	if (world.getSeasonManager().getCurrentSeason() != null && world.getSeasonManager().getCurrentSeason().hasFallingLeaves) {
+    public void animationTick(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Random rand) {
+        if (world.getSeasonManager().getCurrentSeason() != null && world.getSeasonManager().getCurrentSeason().hasFallingLeaves) {
             WindProvider wind = world.getWorldType().getWindManager();
-            float windIntensity = wind.getWindIntensity(world, tilePos.x, tilePos.y, tilePos.z);
-            if (rand.nextInt((int)(40 + 200 * (1 - windIntensity))) == 0)
-            {
-                world.spawnParticle("fallingleaf", tilePos.x, (double) tilePos.y - 0.1f, tilePos.z, 0, 0, 0, 0);
+            float windIntensity = wind.getWindIntensity(world, tilePos.x(), tilePos.y(), tilePos.z());
+            if (rand.nextInt((int) (40 + 200 * (1 - windIntensity))) == 0) {
+                world.spawnParticle("fallingleaf", tilePos.x(), (double) tilePos.y() - 0.1f, tilePos.z(), 0, 0, 0, 0);
             }
-    	}
+        }
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLeavesPine.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLeavesPine.java
index 911e95f98..7b52f582d 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLeavesPine.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLeavesPine.java
@@ -1,10 +1,10 @@
 package net.minecraft.core.block;
 
 import net.minecraft.core.block.entity.TileEntity;
+import net.minecraft.core.block.material.Materials;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.world.World;
-import net.minecraft.core.block.material.Material;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
@@ -13,7 +13,7 @@ public class BlockLogicLeavesPine extends BlockLogicLeavesBase
 
 	public BlockLogicLeavesPine(@NotNull Block<?> block)
     {
-        super(block, Material.leaves, Blocks.SAPLING_PINE);
+        super(block, Materials.LEAVES, Blocks.SAPLING_PINE);
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLeavesShrub.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLeavesShrub.java
index 781cbe926..a5da68337 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLeavesShrub.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLeavesShrub.java
@@ -1,8 +1,8 @@
 package net.minecraft.core.block;
 
+import net.minecraft.core.block.material.Materials;
 import net.minecraft.core.world.World;
-import net.minecraft.core.block.material.Material;
-import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 
 import java.util.Random;
@@ -12,13 +12,13 @@ public class BlockLogicLeavesShrub extends BlockLogicLeavesBase
 
 	public BlockLogicLeavesShrub(@NotNull Block<?> block)
     {
-        super(block, Material.leaves, Blocks.SAPLING_SHRUB);
+        super(block, Materials.LEAVES, Blocks.SAPLING_SHRUB);
     }
 
     @Override
-	public void animationTick(@NotNull World world, @NotNull TilePos tilePos, @NotNull Random rand) {
+	public void animationTick(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Random rand) {
         if (world.getSeasonManager().getCurrentSeason() != null && world.getSeasonManager().getCurrentSeason().hasFallingLeaves && rand.nextInt(40) == 0) {
-            world.spawnParticle("fallingleaf", tilePos.x, (double) tilePos.y - 0.1f, tilePos.z, 0, 0, 0, 0);
+            world.spawnParticle("fallingleaf", tilePos.x(), (double) tilePos.y() - 0.1f, tilePos.z(), 0, 0, 0, 0);
         }
     }
 }
